#ifndef __MIVALIB__
#define __MIVALIB__

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>
#include <math.h>
#include <ctype.h>

// DATA TYPES

#define BYTE unsigned char
#define WORD unsigned int
#define DWORD unsigned long
#define BUL WORD
#define TRUE 1
#define FALSE 0

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;

// DATA TYPE CONVERSION MACROSES

#define WW2DW(x,y) ((((DWORD)(x))<<16)|((DWORD)(y)))
#define DW2WL(x)   ((WORD)(x))
#define DW2WH(x)   ((WORD)((x)>>16))
#define HI(x) (*(((BYTE*)(&(x)))+1))
#define LO(x) (*(((BYTE*)(&(x)))  ))
#define RGB(r,g,b) ((((((DWORD)(r))<<8)|((DWORD)(g)))<<8)|(((DWORD)(b))))
#define R(col) ((WORD)(((DWORD)col)>>16))
#define G(col) ((WORD)(((DWORD)col)>>8))
#define B(col) ((WORD)((DWORD)col))
#define WHITE    0x00FFFFFFL
#define BLACK    0x00000000L
#define RED      0x00FF0000L
#define GREEN    0x0000FF00L
#define BLUE     0x000000FFL
#define YELLOW   0x00FFFF00L
#define MAGENTA  0x00FF00FFL
#define CYAN     0x0000FFFFL
#define lWHITE   0x00808080L
#define lRED     0x00800000L
#define lGREEN   0x00008000L
#define lBLUE    0x00000080L
#define lYELLOW  0x00808000L
#define lMAGENTA 0x00800080L
#define lCYAN    0x00008080L
#define GRAY     0x00404040L

typedef struct {
	BYTE b;
	BYTE g;
	BYTE r;
	BYTE f;
} sRGB;

//--------------------------------------------- L_VGRAPH

#define V_ATTR 			bVESA[0]
#define 	V_SUPP			0x01
#define 	V_BIOS			0x04
#define 	V_COLOR			0x08
#define 	V_GRAPH			0x10
#define V_SCANLINE 	bVESA[0x10]
#define V_PLANES 		bVESA[0x18]
#define V_BPP 			bVESA[0x19]
#define V_BANKS 		bVESA[0x1A]
#define V_BANKSIZE 	bVESA[0x1C]
#define V_PAGES 		bVESA[0x1D]
#define V_320x200x15   0x10D
#define V_320x200x16   0x10E
#define V_320x200x24   0x10F
#define V_640x480x8    0x101
#define V_640x480x15   0x110
#define V_640x480x16   0x111
#define V_640x480x24   0x112
#define V_800x600x8    0x103
#define V_800x600x15   0x113
#define V_800x600x16   0x114
#define V_800x600x24   0x115
#define V_1024x768x8   0x105
#define V_1024x768x15  0x116
#define V_1024x768x16  0x117
#define V_1024x768x24  0x118
#define V_1280x1024x8  0x107
#define V_1280x1024x15 0x119
#define V_1280x1024x16 0x11A
#define V_1280x1024x24 0x11B
#define V_1600x1200x8  0x120
#define XORMODE  0x02000000L
#define GETMODE  0x01000000L
#define SKIPMODE 0x04000000L
#define MUSTSET  0x8000

WORD	getGraphMode(int width);
WORD	setGraphMode(int mode);
WORD	setTextMode(void);
void	setColor(DWORD color);
void	setTextColor(DWORD fcolor,DWORD bcolor);
DWORD	setPixel(WORD x, WORD y);
void	setLine (WORD x0, WORD y0, WORD x1, WORD y1);
void 	setBox  (WORD x0, WORD y0, WORD x1, WORD y1);
DWORD	setPixelColor(WORD x, WORD y, DWORD col);
void	setLineColor (WORD x0, WORD y0, WORD x1, WORD y1, DWORD col);
void 	setBoxColor  (WORD x0, WORD y0, WORD x1, WORD y1, DWORD col);
DWORD	getPixel(WORD x, WORD y);
void	setFont(char* font);
void	pChar(BYTE c);
void	pString(char* str);
void	pDwordHex(DWORD l);
void	pWordHex(WORD i);
void	pByteHex(BYTE c);
void	pNibbleHex(BYTE n);
WORD	mouseInit(WORD com_port, WORD port, WORD irq);
WORD	mouseExit(void);
void	mouseOn(void);
void	mouseOff(void);
void	mouseMove(WORD x, WORD y);
void	mouseRefresh(void);

typedef struct{
	WORD width;
	WORD height;
	WORD max_width;
	WORD ascent;
	WORD int_lead;
	WORD ext_lead;
	BYTE fst_char;
	BYTE lst_char;
} font;
int getFontMetrics(char* font, font* fnt);

#define SF_GETWIDTH   0x0001
#define SF_GETHEIGHT  0x0002
#define SF_XCENTER    0x0004
#define SF_YCENTER    0x0008
#define SF_LOWBASE    0x0010
#define SF_USECOLOR   0x0020
#define SF_WITHHDR    0x0040
#define SF_WITHFRM    0x0080
#define SF_WAITKEY    0x0100
int pStringFontColor(char* font,int x, int y,char* str,DWORD color, int flags);

extern char bVESA[];
extern WORD v_width;
extern WORD v_height;
extern WORD v_mode;
extern WORD text_x;
extern WORD text_y;
extern WORD char_width;
extern WORD char_height;
extern DWORD plot_color;
extern DWORD text_backcolor;
extern DWORD text_forecolor;
extern WORD mouse_x;
extern WORD mouse_y;
extern WORD mouse_minx;
extern WORD mouse_miny;
extern WORD mouse_maxx;
extern WORD mouse_maxy;
extern WORD mouse_butt;
extern WORD left_off_cnt;
extern WORD left_on_cnt;
extern WORD left_off_x;
extern WORD left_off_y;
extern WORD left_on_x;
extern WORD left_on_y;
extern WORD right_off_cnt;
extern WORD right_on_cnt;
extern WORD right_off_x;
extern WORD right_off_y;
extern WORD right_on_x;
extern WORD right_on_y;
extern WORD middle_off_cnt;
extern WORD middle_on_cnt;
extern WORD middle_off_x;
extern WORD middle_off_y;
extern WORD middle_on_x;
extern WORD middle_on_y;
extern WORD mouse_event;
// mouse_event:
// D0 - mouse moved, current coordinates in mouse_x/mouse_y
// D1 - left button was pressed in left_on_x/left_on_y
// D2 - left button was released in left_off_x/left_off_y
// D3 - right button was pressed in   right_on_x/right_on_y
// D4 - right button was released in right_off_x/right_off_y
// D5 - middle button was pressed in   middle_on_x/middle_on_y
// D6 - middle button was released in middle_off_x/middle_off_y
// D7

//--------------------------------------------- L_VESA

WORD	vesaGetInfo(char* buf);
typedef struct {
	char signature[4];	// must contain "VBE2" on call to receive v2.0 info
	int  vesavers;
	char far* oem_name;
	long capabil;				// see CAPABIL_xxx
#define CAPABIL_8BIT		0x00000001
#define CAPABIL_NONVGA	0x00000002
#define CAPABIL_PROGDAC	0x00000004
	int far* modes;
	int memsize;
	int	oem_version;
	char far* vendor_name;
	char far* prod_name;
	char far* prod_revision;
} vesainfo;
WORD 	vesaGetModeInfo(int mode, char* buf);
typedef struct {
	int attrib;					// see ATTRIB_xxx
#define ATTRIB_SUPP			0x0001
#define ATTRIB_OPTINFO	0x0002
#define ATTRIB_BIOS			0x0004
#define ATTRIB_COLOR		0x0008
#define ATTRIB_GRAPH		0x0010
#define ATTRIB_NONVGA		0x0020
#define ATTRIB_NOBANK		0x0040
#define ATTRIB_LINEAR		0x0080
	char winAattr;			// see WINATTR_xxx
	char winBattr;			// see -||-
#define WINATTR_EXISTS	0x01
#define	WINATTR_READ		0x02
#define WINATTR_WRITE		0x04
	int	wingran;				// window granularity in Kb
	int winsize;				// window size in Kb
	int winAstart;			// window A start segment
	int winBstart;			// window B start segment
	char far* winfunc;	// window positioning function ptr
	int bytesperscan;		// bytes per scan line
	int	charwidth;			// width in pixels (graphics) or characters (text)
	int charheight;			// height in pixels (graphics) or characters (text)
	char cellwidth;			// width of character cell in pixels
	char cellheight;			// height of character cell in pixels
	char memplanes;			// number of memory planes
	char bitperpixel;		// number of bits per pixel
	char banks;					// number of banks
	char memmodel;			// memory model type (see MEMxxx)
#define MEMTEXT					0x00
#define MEMCGAGRAPH			0x01
#define MEMHGCGRAPH			0x02
#define MEMEGA16COL			0x03
#define MEMPACKEDPIX		0x04
#define MEMSEQU256			0x05
#define MEMDIRCOLOR			0x06
#define MEMYUV					0x07
	char banksize;			// size of bank in KB
	char imagepages;		// number of image pages
	char reserved;
	char redmasksize;		// red mask size
	char redmaskpos;		// red field position
	char greenmasksize;	// green mask size
	char greenmaskpos;	// green field position
	char bluemasksize;	// blue mask size
	char bluemaskpos;		// blue field position
	char resmasksize;		// reserved mask size
	char resmaskpos;		// reserved field position
	char dircolorinfo;	// direct color mode info
#define DIRCOLRAMP			0x01
#define DIRCOLMAYUSE		0x02
	long linearptr;			// physical address of linear video buffer
	long offscreenptr;	// pointer to start of offscreen memory
	int offscreensize;	// KB of offscreen memory
} vesamodeinfo;
WORD 	vesaSetMode(int mode);
WORD	vesaGetMode(void);
WORD	vesaStateGetSize(void);
WORD	vesaStateSave(int flags, char* buf);
WORD	vesaStateRestore(int flags, char* buf);
WORD	vesaWindowSet(int win, int addr);
WORD	vesaWindowGet(int win);

//--------------------------------------------- L_TIMER

void	startRTC(void);
void	stopRTC(void);
DWORD	readRTC(void);
#define SECOND_RTC 8192
void	waitRTC(long del);
void	resetRTC(void);
void	presetRTC(long del);
DWORD	resetTimer(void);
DWORD	readTimer(void);		// 3.4uS / operation ( correction = -4 )
#define MILLISECOND 1193L
#define SECOND 1193167L
DWORD	waitTimer(long del);
DWORD	timeRTC(void);
WORD	timeH(DWORD tim);
WORD	timeM(DWORD tim);
WORD	timeS(DWORD tim);
#define SEC_IN_DAY 86400L
#define SEC_IN_HALFDAY 43200L

//--------------------------------------------- L_KEYBRD

WORD	getKey(int mode);
#define NOWAITKEY 0
#define WAITKEY 1

WORD	getShift(void);
#define KEYSHIFTRT	0x0001
#define KEYSHIFTLT	0x0002
#define KEYCTRL			0x0004
#define KEYALT			0x0008
#define	KEYSCROLL		0x0010
#define	KEYNUM			0x0020
#define	KEYCAPS			0x0040
#define	KEYINSERT		0x0080
#define KEYCTRLLT		0x0100
#define KEYALTLT		0x0200
#define KEYSYSREQ		0x0400
#define KEYPAUSE		0x0800
#define KEYSCROLLDN	0x1000
#define KEYNUMDN		0x2000
#define KEYCAPSDN		0x4000
#define KEYINSDN		0x8000

WORD getrand(WORD lim);

#define MOUSELEFT 0x0001
#define MOUSERIGHT 0x0002

extern char font8x8[];

// FILE I/O LIBRARY

#define READMODE 0
#define WRITEMODE 1

#define FAIL 0xFFFF
#define _OK_ 0
#define FLUSH 0xFFFF

WORD  fio_close(WORD fnum);
WORD  fio_open (char* fname, WORD mode);
WORD  moveptr  (WORD fnum, DWORD pos);// moves file pointer, ret _OK_ or FAIL
WORD  getbyte  (WORD fnum);						// read byte, ret byte or FAIL
WORD  getbit   (WORD fnum);						// read bit, ret bit or FAIL
WORD  getbits  (WORD fnum, int len);	// read len bits, ret bits or FAIL
WORD  putbyte  (WORD fnum, WORD sym);	// write byte, ret _OK_ or FAIL
WORD  putbit   (WORD fnum, WORD bit);	// write bit, ret _OK_ or FAIL
WORD  putbits  (WORD fnum, WORD sym, int len);// write len bits,  ret _OK_ or FAIL
DWORD getpos   (WORD fnum);

WORD	memoryInit(void);               // 0 if failed
WORD	memoryExit(void);
WORD	memoryAlloc(int bytes);         // 0xFFFF if failed or memory handle
//int memoryAllocLong(long bytes);
WORD	memoryFree(int memhan);         // 0 if failed
WORD	memoryPhys(int memhan);        // 0 if failed or memory paragraph
WORD	memorySize(void);

WORD	log_file(char* message, char* filename);
void	log_on(void);
void	log_off(void);

WORD	unpackGIF(char* gifname, WORD mode);

WORD	showImage(WORD x, WORD y, WORD mode, WORD imghan);
WORD	showBuffer(WORD bufhan, WORD xnew, WORD ynew);
WORD	saveBuffer(WORD x0, WORD y0, WORD x1, WORD y1);
WORD	showGIF(char* gifname, WORD x, WORD y, WORD mode);

#define CENTERMODE 0x8000

WORD readSect(WORD drive, WORD head, WORD track, WORD sect, WORD cnt, DWORD buf);
WORD writeSect(WORD drive, WORD head, WORD track, WORD sect, WORD cnt, DWORD buf);
WORD seekTrack(WORD drive, WORD head, WORD track);
void getDriveCHS(WORD drive, DWORD heads, DWORD tracks, DWORD sects);
WORD checkDrivePresent(WORD drive);

WORD getIni(char* inifile,char* name, char* result);
int getIniWord(char* inifile, char* name, WORD def);

void bigChar(WORD x, WORD y, WORD c, WORD siz);
void bigString(WORD x, WORD y, char* str, WORD siz);
void setFrame(WORD x0, WORD y0, WORD x1, WORD y1);
void setFrameColor(WORD x0, WORD y0, WORD x1, WORD y1, DWORD color);

// FOLLOWING ARE THE TEXT MODE WINDOW FUNCTIONS

WORD get_videomode(void);
void set_videomode(WORD mode);
void save_window(char far* _ptr, WORD oldwin);
WORD restore_window(char far* _ptr);
void set_charcolor(WORD x, WORD y, WORD chr, WORD color);
WORD get_char(WORD x, WORD y);
WORD get_color(WORD x, WORD y);
void move_cursor(WORD x, WORD y);
void show_cursor(WORD shape);
void set_blink(WORD mod);

extern WORD screen_dx;
extern WORD screen_dy;
extern WORD win_x;
extern WORD win_y;
extern WORD win_dx;
extern WORD win_dy;
extern WORD win_color;
extern WORD curs_x;
extern WORD curs_y;
extern WORD curs_shape;

void fill_window(WORD color, WORD chr);
void box_window(WORD color, char* box);
WORD open_window(WORD x, WORD y, WORD dx, WORD dy, WORD color, char* box);
WORD close_window(void);
void flush_windows(void);
void set_symbol(WORD chr);
int  set_string(char* str, WORD x, WORD y);
WORD message_window(char* header, char* message, WORD color, char* box);

typedef struct {
	char* msg;
	char* msgfont;
	char* hdr;
	char* hdrfont;
	DWORD msgback;
	DWORD msgfore;
	DWORD hdrback;
	DWORD hdrfore;
	DWORD frmfore;
	int flags;
} s_mes;

int GBox(s_mes* mes);


#endif
