#include <conio.h>
#include <stdio.h>
#include "ofscomu.h"

#define POUT(x) outp(c_out_port,x)
#define PIN() inp(in_port)
#define BUSY (PIN() & 0x08)
#define DBLSET(d) POUT(0x20|d); POUT(0x20|d)

byte t00,t01,t02,t03,t04,t05;
byte x00,x01,x02;

int c_out_port,in_port,d_out_port;
long timer_1us;
long tmpdelay;

int lptaddr[]={0x378,0x278,0x3BC,0};

void Port_Initialise(int portnum)
{
	long tim, lcnt;

	tim=GetCurrentTime()+200L;
  lcnt=0L; while ( GetCurrentTime()<tim ) lcnt++;
  if ( !(timer_1us=lcnt/100000L) ) timer_1us=1;
	c_out_port=(in_port=(d_out_port=lptaddr[portnum-1])+1)+1;
  POUT(0x24);
}

// delay will be 0.4uS per ldelay

void wait_1us(long ldelay)
{
	long lcnt;
	ldelay<<=1;
	while ( ldelay-- ) {
		lcnt=0L; while ( lcnt<timer_1us ) lcnt++;
	}
}

void send_sub(byte dat)
{
	DBLSET(0x02);
	while ( !BUSY ) ;
	if ( dat & 0x80 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x40 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x20 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x10 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x08 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x04 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x02 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	if ( dat & 0x01 ) { DBLSET(0x02); wait_1us(10); DBLSET(0x00); }
	else              { DBLSET(0x0A); wait_1us(10); DBLSET(0x08); }
	wait_1us(10L);
	DBLSET(0x00);
	wait_1us(100L);
}

void send_word(word w)
{
  send_sub(*(((byte*)(&w))+1));
  send_sub(*(((byte*)(&w))  ));
}

void send_dword(dword d)
{
	send_sub(*(((byte*)(&d))+3));
	send_sub(*(((byte*)(&d))+2));
	send_sub(*(((byte*)(&d))+1));
	send_sub(*(((byte*)(&d))  ));
}

int PixelRead(byte* r, byte* g, byte* b)
{
  tmpdelay=1000000L*timer_1us;
  while ( BUSY ) { if ( ! (--tmpdelay) ) { POUT(0x24); return 0; } }
	DBLSET(0x0A); t00=PIN();
	DBLSET(0x08); t01=PIN();
	DBLSET(0x0A); t02=PIN();
	DBLSET(0x08); t03=PIN();
	DBLSET(0x0A); t04=PIN();
	DBLSET(0x08); t05=PIN();
	DBLSET(0x00);
	*r=((t00)&0xF0)|(t01>>4);
	*g=((t02)&0xF0)|(t03>>4);
	*b=((t04)&0xF0)|(t05>>4);
	return 1;
}

int scanner_data_read(byte* b0, byte* b1, byte* b2)
{
  tmpdelay=1000000L*timer_1us;
  while ( BUSY ) { if ( ! (--tmpdelay) ) { POUT(0x24); return 0; } }
  DBLSET(0x0A); t00=PIN();
  DBLSET(0x08); t01=PIN();
  DBLSET(0x0A); t02=PIN();
  DBLSET(0x08); t03=PIN();
  DBLSET(0x0A); t04=PIN();
  DBLSET(0x08); t05=PIN();
  DBLSET(0x00);
  while ( !BUSY ) ;
	*b0=((t00)&0xF0)|(t01>>4);
	*b1=((t02)&0xF0)|(t03>>4);
	*b2=((t04)&0xF0)|(t05>>4);
	return 1;
}

int Get_Status_Start_Phase(void)
{
	DBLSET(0x00);
  tmpdelay=GetCurrentTime()+7000L;
  while ( !BUSY ) if ( GetCurrentTime()>tmpdelay ) { POUT(0x24); wait_1us(10000L); return 0; }
  tmpdelay=GetCurrentTime()+1000L;
  while (  BUSY ) if ( GetCurrentTime()>tmpdelay ) { POUT(0x24); wait_1us(10000L); return 0; }
	wait_1us(10000L);
	return 1;
}

int Start_Phase(void)
{
	DBLSET(0x00);
  tmpdelay=GetCurrentTime()+1000L;
  while (  BUSY ) if ( GetCurrentTime()>tmpdelay ) { POUT(0x24); wait_1us(10000L); return 0; }
	wait_1us(10000L);
	return 1;
}

int Waiting_Phase(void)
{
  tmpdelay=1000000L*timer_1us;
  while (  BUSY ) if ( !(--tmpdelay) ) { POUT(0x24); return 0; }
	while ( !BUSY ) ;
  POUT(0x24);
	wait_1us(5000L);
	return 1;
}

int RamRead(byte bank,byte* buf, int adr, int len)  // buf - len bytes
{
	int cnt;

	if ( !Start_Phase() ) return 0;
	send_sub(0x28);
	send_sub(  0 );
	send_sub(bank);
	send_sub(  0 );
  send_word(adr);
	send_sub(  0 );
	send_sub(  0 );
	send_sub( len);
	send_sub(  0 );
	Waiting_Phase();
	DBLSET(0x00);
	wait_1us(100L);
	cnt=0;
	while ( cnt<len+3 ) {
		scanner_data_read( &x00, &x01, &x02);
		buf[cnt++]=x00;
		buf[cnt++]=x01;
		buf[cnt++]=x02;
	}
  POUT(0x24);
	wait_1us(10000L);
	return 1;
}

int Focus(byte d)
{
	if ( !Start_Phase() ) return 0;
	send_sub(0xD5);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  d );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int CCD_Check(byte d)
{
	if ( !Start_Phase() ) return 0;
	send_sub(0xE0);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  d );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int Set_Scan_Mode(byte d, byte* buf)  // buf - 4/7 bytes
{
	if ( !Start_Phase() ) return 0;
	send_sub(0xD2);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  d );
	send_sub(  0 );
	send_sub(buf[0]);
	send_sub(buf[1]);
	send_sub(buf[2]);
	send_sub(buf[3]);
	if ( d==7 ) {
		send_sub(buf[4]);
		send_sub(buf[5]);
		send_sub(buf[6]);
	}
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int Set_Window(scan_win* swin) // buf - 31 byte
{
	if ( !Start_Phase() ) return 0;
  send_dword(0x24000000L);
  send_dword(0x28000000L);
	send_word( swin->resX);
	send_word( swin->resY);
	send_dword(swin->X);
	send_dword(swin->Y);
	send_dword(swin->dX);
	send_dword(swin->dY);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
  send_sub(swin->win0);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
  send_sub(swin->win1);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int Set_Brightness(byte br)
{
	if ( !Start_Phase() ) return 0;
  send_dword(0xD4000000L);
	send_sub( br );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int Get_Status(word* stat)  // stat - 2 bytes
{
	if ( !Get_Status_Start_Phase() ) return 0;
  send_dword(0xD0000000L);
  send_sub(2); send_sub(0);
	Waiting_Phase();
	DBLSET(0x00);
	wait_1us(100L);
  scanner_data_read( ((byte*)stat), ((byte*)stat)+1, &x02);
  POUT(0x24);
	wait_1us(10000L);
	return 1;
}

int Reset_Scanner(void)
{
	POUT(0x21); POUT(0x21);
	wait_1us(5000L);
	DBLSET(0x00);
  tmpdelay=GetCurrentTime()+ 500L; while (  BUSY ) if ( GetCurrentTime()>=tmpdelay ) { POUT(0x24); wait_1us(10000L); return 0; }
  tmpdelay=GetCurrentTime()+6000L; while ( !BUSY ) if ( GetCurrentTime()>=tmpdelay ) { POUT(0x24); wait_1us(10000L); return 0; }
  POUT(0x24);
	wait_1us(10000L);
	return 1;
}

int ScanStart(void)
{
	if ( !Start_Phase() ) return 0;
  send_dword(0x1B000000L);
	send_sub(  0 );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int ContrastRead(byte* b0, byte* b1, byte* b2)
{
	DBLSET(0x00);
	wait_1us(100L);
  tmpdelay=1000000L*timer_1us; while ( BUSY ) if ( !(--tmpdelay) ) { POUT(0x24); return 0; }
	DBLSET(0x0A); t00=PIN();
	DBLSET(0x08); t01=PIN();
	DBLSET(0x0A); t02=PIN();
	DBLSET(0x08); t03=PIN();
	DBLSET(0x0A); t04=PIN();
	DBLSET(0x08); t05=PIN();
  POUT(0x24);
	*b0=((t00)&0xF0)|(t01>>4);
	*b1=((t02)&0xF0)|(t03>>4);
	*b2=((t04)&0xF0)|(t05>>4);
	return 1;
}

int LineStart(void)
{
	DBLSET(0x00);
	wait_1us(100L);
	return 1;
}

int LineEnd(void)
{
  tmpdelay=1000000L*timer_1us;
  while ( BUSY ) if ( !(--tmpdelay) ) { POUT(0x24); return 0; }
  DBLSET(0x0A); t00=PIN();
  DBLSET(0x08); t01=PIN();
  DBLSET(0x0A); t02=PIN();
  DBLSET(0x08); t03=PIN();
  DBLSET(0x0A); t04=PIN();
  DBLSET(0x08); t05=PIN();
  POUT(0x24);
	wait_1us(5000L);
	return 1;
}

int ScanEnd(void)
{
	DBLSET(0x00);
  tmpdelay=1000000L*timer_1us; while ( BUSY ) if ( !(--tmpdelay) ) { POUT(0x24); return 0; }
  DBLSET(0x0A);
  wait_1us(20);
  DBLSET(0x02);
	while ( !BUSY ) ;
  tmpdelay=1000000L*timer_1us; while ( BUSY ) if ( !(--tmpdelay) ) { POUT(0x24); return 0; }
	DBLSET(0x00);
	while ( !BUSY ) ;
  POUT(0x24);
	return 1;
}

int Set_AD(byte* buf) // buf - 20 bytes
{
	if ( !Start_Phase() ) return 0;
  send_dword(0xD1000000L);
	send_sub(  0 );
	send_sub(  0 );
  send_sub(buf[ 0]); send_sub(buf[ 1]); send_sub(buf[ 2]); send_sub(buf[ 3]);
  send_sub(buf[ 4]); send_sub(buf[ 5]); send_sub(buf[ 6]); send_sub(buf[ 7]);
  send_sub(buf[ 8]); send_sub(buf[ 9]); send_sub(buf[10]); send_sub(buf[11]);
  send_sub(buf[12]); send_sub(buf[13]); send_sub(buf[14]); send_sub(buf[15]);
  send_sub(buf[16]); send_sub(buf[17]); send_sub(buf[18]); send_sub(buf[19]);
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int Reset_APS_Adapter(void)
{
	if ( !Start_Phase() ) return 0;
  send_dword(0xD9000000L);
	send_sub(  0 );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(100000L);
	return 1;
}

int EepromWrite(byte* buf, int adr, int len)
{
	int cnt;

	if ( !Start_Phase() ) return 0;
	send_sub(0x2A);
	send_sub(  0 );
	send_sub( 'E' );
	send_sub(  0 );
	send_sub(  0 );
	send_sub( adr);
	send_sub(  0 );
	send_sub(  0 );
	send_sub( len);
	send_sub(  0 );
	cnt=0;
	while ( cnt<len ) send_sub(buf[cnt]);
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int EepromRead(byte* buf, int adr, int len)
{
	int cnt;

	if ( !Start_Phase() ) return 0;
	send_sub(0x28);
	send_sub(  0 );
	send_sub( 'E');
	send_sub(  0 );
	send_sub(  0 );
	send_sub( adr);
	send_sub(  0 );
	send_sub(  0 );
	send_sub( len);
	send_sub(  0 );
	Waiting_Phase();
	DBLSET(0x00);
	wait_1us(100L);
	cnt=0;
	while ( cnt<len ) {
		scanner_data_read( &x00, &x01, &x02);
		buf[cnt++]=x00;
		buf[cnt++]=x01;
		buf[cnt++]=x02;
	}
  POUT(0x24);
	wait_1us(10000L);
	return 1;
}

// bank - 'r' or 'R' buf
int RamWrite(byte bank, int adr, int len, int dat)
{
	if ( !Start_Phase() ) return 0;
	send_sub(0x2A);
	send_sub(  0 );
	send_sub(bank);
	send_sub(  0 );
	send_word(adr);
	send_sub(  0 );
	send_sub(  0 );
	send_sub( len);
	send_sub(  0 );
	if ( len ) send_sub(dat);
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}

int FilmHeadPosition(byte dir, int x_pos)
// dir=1 APS auto load  =6 move head to right =7 move head to left
{
	if ( !Start_Phase() ) return 0;
	send_sub(0x31);
	send_sub(dir&7);
	send_sub(  0 );
	send_word(x_pos);
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	send_sub(  0 );
	Waiting_Phase();
	wait_1us(10000L);
	return 1;
}
