#include <mem.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ofscomu.h"
#include "mivalib.h"
#include "bmp.h"

#define SYSCOLOR lBLUE

#define XOFF 4
#define YOFF 4

#define BASPARAM 20 // base parameters - Vrefs etc
#define ALLPARAM 21 // additional parameters - as Lamp etc

// this is where and how focus will be shown
#define FWIDTH 8
#define FBEGX (((v_width<<2)/5)+3*XOFF)
#define FBEGY (YOFF+3*char_height)

#define TEXTBEGX (FBEGX+FWIDTH+char_width)


// this is where and how parameters will be shown
#define PARAM_X (XOFF+((6+1)*char_width))
#define PARAM_DY (char_height+3)
#define PARAM_BRD 1
#define PARAM_Y ( v_height-ALLPARAM*(PARAM_DY+PARAM_BRD)-YOFF )

#define MESSAGEX (XOFF)
#define MESSAGEY (PARAM_Y-40)

//int FilmParameterLoad(byte* name);
//void Eeprom_comp_load(void);
//void pal_cal_preview(void);
//void pal_set_common(void);
//byte vref_comp(byte to, byte from);
void MessageBox(char* str);
void plotHistogram(void);
void drawParam(int i, dword color);
int waitClearKbd(void);
int focus_check_sub(int flag);
void setup_scanner(void);
byte* pptr(int i);
void drawNumbers(void);
float get_volt(int k, int col);
void calc_new_ref(word hcrop);
void show_new_ref(int newref,int i);
void recalc3ref(int i);
void infotext(char* s, int row);
void drawHistBack(int x, int y, dword* mx, dword color);

s_mes mes;
dword* h_r;
dword* h_g;
dword* h_b;
dword* h_rm;
dword* h_gm;
dword* h_bm;
int win_dX, win_dY;
int edit_flag;
byte r,g,b;
dword mf,of;
int histdiv;
word showvoltage,basevoltage;
byte byTable,calcHS;
word inbord;
word Vref1, Vref2, Vref3;
word nVpR,nVpG,nVpB,nVmR,nVmG,nVmB;
word dVpR,dVpG,dVpB,dVmR,dVmG,dVmB;

char* fname="__temp__.bmp";

byte isNega=0;      // 34
byte param[ALLPARAM]={    // 39...58
	205,188,160,127,102,
	205,191,159,121,100,
	207,164,125,110, 99,
	198,150,147, 15, 45,
	150
//byte cLatitude='H'; // 59
//byte Latitude ='S'; // 59
//int dBias;	// -200...200
// \\
};

char* sParam[ALLPARAM]={
	"RVpls ",  "RVm3  ",   "RVm2  ",   "RVm1  ",   "RVmin ",
	"GVpls ",  "GVm3  ",   "GVm2  ",   "GVm1  ",   "GVmin ",
	"BVpls ",  "BVm3  ",   "BVm2  ",   "BVm1  ",   "BVmin ",
	"RGain ",
	"GGain ",
	"BGain ",
	"ITim1 ",
	"ITim2 ",
	"Lamp  "//,
//	"bias"
};

byte cp_param[BASPARAM];

byte* eeprom;

word Vref[21][3]={
{2490,5000,7510},
{2123,4662,7287},
{1810,4343,7071},
{1542,4042,6859},
{1313,3761,6652},
{1118,3496,6451},
{ 950,3249,6254},
{ 807,3017,6061},
{ 684,2801,5873},
{ 579,2598,5689},
{ 490,2410,5509},
{ 413,2234,5334},
{ 347,2070,5162},
{ 291,1918,4994},
{ 243,1776,4831},
{ 202,1645,4671},
{ 167,1522,4514},
{ 137,1409,4362},
{ 112,1303,4213},
{	 91,1205,4067},
{	 73,1115,3925}};

byte cPosi[]={
0x00,0x03,0x06,0x09,0x0C,0x0E,0x11,0x13,0x15,0x17,0x19,0x1B,0x1D,0x1F,0x21,0x23,
0x25,0x27,0x28,0x2A,0x2C,0x2D,0x2F,0x30,0x32,0x33,0x35,0x36,0x38,0x39,0x3A,0x3C,
0x3D,0x3E,0x3F,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x4A,0x4B,0x4C,0x4D,0x4E,
0x4F,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x57,0x58,0x59,0x5A,0x5B,0x5B,
0x5C,0x5D,0x5E,0x5F,0x5F,0x60,0x61,0x61,0x62,0x63,0x64,0x64,0x65,0x66,0x66,0x67,
0x67,0x68,0x69,0x69,0x6A,0x6B,0x6B,0x6C,0x6D,0x6D,0x6E,0x6E,0x6F,0x70,0x70,0x71,
0x71,0x72,0x73,0x73,0x74,0x74,0x75,0x75,0x76,0x77,0x77,0x78,0x78,0x79,0x7A,0x7A,
0x7B,0x7B,0x7C,0x7D,0x7D,0x7E,0x7E,0x7F,0x80,0x80,0x81,0x81,0x82,0x83,0x83,0x84,
0x84,0x85,0x86,0x86,0x87,0x88,0x88,0x89,0x8A,0x8A,0x8B,0x8C,0x8C,0x8D,0x8E,0x8E,
0x8F,0x90,0x91,0x91,0x92,0x93,0x93,0x94,0x95,0x96,0x96,0x97,0x98,0x99,0x9A,0x9A,
0x9B,0x9C,0x9D,0x9E,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,
0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAE,0xAF,0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC5,0xC6,0xC7,0xC8,0xC9,
0xCA,0xCB,0xCD,0xCE,0xCF,0xD0,0xD1,0xD3,0xD4,0xD5,0xD6,0xD8,0xD9,0xDA,0xDC,0xDD,
0xDE,0xDF,0xE1,0xE2,0xE3,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};
/*
byte cNega[]={
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};
*/
void main(int argc, char** argv)
{
	word scaner_status;
	int scan_dX,scan_dY,scan_X,scan_Y;
	word scan_X_min,scan_X_max,scan_Y_min,scan_Y_max;
	int win_x, win_y, win_nx, win_ny;
	dword win_dY_scan_dX,win_dX_scan_dY;
	dword scan_dX_1770,scan_dY_1770;
	byte rs0,rs1;
	scan_win swin;
	int i;
	int fh;
	int fb;
	bmp_fh bmpfh;
	dword linlen;
	dword t_start, t_done, t_rest;
	char sTime[40];
	dword rgb;
	word iR,iG,iB,iH,iS;
	byte plot_hist;
	byte* b1;	// green color storage for 1-pixel horizontal shift (if res>800 dpi)
	byte* b2;	// green color storage for 2-pixel horizontal shift (if res>1400 dpi)
	byte* brtbl;
	byte cshift;
	int key;
	int prm;
	int focus_x,focusX;
	int LPTnum;
	char filmini[40];
	char filmname[40];
	char shadowini[40];
	char gammaini[40];
	byte prm_changed;
	dword tul;
	word gamma;
	word histcrop;
	word borders;
	dword dpi;

	b1=b2=eeprom=brtbl=NULL;
	h_r=h_g=h_b=h_rm=h_gm=h_bm=NULL;
	rgb=0L;
	plot_hist=0;
	fh=fb=0;

	focusX=0;

	mes.msgfont="s70.fnt";
	mes.msgback=lRED;
	mes.msgfore=YELLOW;
	mes.frmfore=BLACK;
	mes.flags=SF_XCENTER|SF_USECOLOR|SF_WITHFRM;

  if ( argc>1 ) fname=argv[1];

	if ( setGraphMode(MUSTSET|(i=getGraphMode(getIniWord("scan.ini","vmode",1024))))==FAIL ) {
		printf("! Failed to set VESA video mode 0x%X\n",i);	return;
	}
	setBoxColor(0,0,v_width-1,v_height-1,SYSCOLOR);

	if ( (!(h_r =(dword*)malloc(4*256))) ||
			 (!(h_g =(dword*)malloc(4*256))) ||
			 (!(h_b =(dword*)malloc(4*256))) ||
			 (!(h_rm=(dword*)malloc(4*256))) ||
			 (!(h_gm=(dword*)malloc(4*256))) ||
			 (!(h_bm=(dword*)malloc(4*256))) ) {
			 mes.msg="MEMORY\nCannot allocate histogramm buffers"; goto scan_error; }
	if ( !(eeprom=malloc(512))  ) { mes.msg="MEMORY\nCannot allocate eeprom"; goto scan_error; }
	if ( !(brtbl=malloc(3*2049)) ) { mes.msg="MEMORY\nCannot allocate BrTable"; goto scan_error; }
	if ( !(b1=malloc(2*1800)) ) { mes.msg="MEMORY\nCannot allocate DelayBuffer1"; goto scan_error; }
	if ( !(b2=malloc(2*1800)) ) { mes.msg="MEMORY\nCannot allocate DelayBuffer1"; goto scan_error; }

	for ( i=0 ; i<3*2049 ; i++ ) brtbl[i]=0;

	LPTnum=getIniWord("scan.ini","lpt",  1);
	Port_Initialise(LPTnum);

	i=1;
	do {
		while ( ! Get_Status(&scaner_status) ) {
			if ( ! i-- ) { mes.msg="SCANNER\nCannot get status"; goto scan_error; }
			Reset_Scanner();
		}
		if ( ! ( scaner_status & 0x08 ) ) {
			if ( ! (scaner_status & 0x04) ) goto no_adapt;
			if ( ! (scaner_status & 0x01) ) FilmHeadPosition(7,3000);
			goto scanner_ok;
		}
	} while ( i-- ) ;
no_adapt:;
	mes.msg="SCANNER\nNo film adapter mounted";
	goto scan_error;

scanner_ok:;

	getIni("scan.ini","filmini",filmini);   if ( !(*filmini)   ) strcpy(filmini,"film.ini");
	getIni("scan.ini","shadow",shadowini);	if ( *shadowini ) if ( (fb=_open(shadowini,O_RDWR))!=-1 ) _read(fb,brtbl,3*2049); else fb=0;
	showvoltage =getIniWord("scan.ini","showvoltage",0);
	basevoltage =getIniWord("scan.ini","basevoltage",4100);
	borders  = getIniWord("scan.ini","borders",0);
	histcrop = getIniWord("scan.ini","histcrop",10);
	histdiv  = getIniWord("scan.ini","histdiv",16);
	byTable  = getIniWord("scan.ini","bytable",0);
	calcHS   = getIniWord("scan.ini","calchs",0);
	edit_flag= getIniWord("scan.ini","edit",0);

	isNega   =(i=getIniWord(filmini,"isnega",0));

	param[ 0]=getIniWord(filmini,"RVpls", 206);
	param[ 4]=getIniWord(filmini,"RVmin", 100);
	param[ 5]=getIniWord(filmini,"GVpls", 206);
	param[ 9]=getIniWord(filmini,"GVmin", 100);
	param[10]=getIniWord(filmini,"BVpls", 206);
	param[14]=getIniWord(filmini,"BVmin", 100);
	param[15]=getIniWord(filmini,"RGain", 150);
	param[16]=getIniWord(filmini,"GGain", 150);
	param[17]=getIniWord(filmini,"BGain", 150);
	param[18]=getIniWord(filmini,"ITim1", (!isNega) ? 15 :  50);
	param[19]=getIniWord(filmini,"ITim2", (!isNega) ? 45 : 100);
// --- not BASE PARAMETERS
	param[20]=getIniWord(filmini,"Lamp",  150);


//////!!!
	if ( !(gamma=getIniWord(filmini,"gamma",0)) ) {
		getIni(filmini,"gammaini",gammaini);
		if ( !gammaini[0] ) {	Vref3=2490; Vref2=5000; Vref1=7510; }
		else {
			Vref3=getIniWord(gammaini,"Vref3", 2490);
			Vref2=getIniWord(gammaini,"Vref2", 5000);
			Vref1=getIniWord(gammaini,"Vref1", 7510);
		}
	}
	else {
		if ( gamma<10 ) gamma=10;
		if ( gamma>30 ) gamma=30;
		Vref3=Vref[gamma-10][0];
		Vref2=Vref[gamma-10][1];
		Vref1=Vref[gamma-10][2];
	}

	if ( ! (param[ 1]=getIniWord(filmini,"RVm3",0)) )	param[ 1]=(int)((float)param[ 0]-((float)param[ 0]-(float)param[ 4])*(float)Vref3/10000.0+0.5);
	if ( ! (param[ 2]=getIniWord(filmini,"RVm2",0)) )	param[ 2]=(int)((float)param[ 0]-((float)param[ 0]-(float)param[ 4])*(float)Vref2/10000.0+0.5);
	if ( ! (param[ 3]=getIniWord(filmini,"RVm1",0)) )	param[ 3]=(int)((float)param[ 0]-((float)param[ 0]-(float)param[ 4])*(float)Vref1/10000.0+0.5);
	if ( ! (param[ 6]=getIniWord(filmini,"GVm3",0)) )	param[ 6]=(int)((float)param[ 5]-((float)param[ 5]-(float)param[ 9])*(float)Vref3/10000.0+0.5);
	if ( ! (param[ 7]=getIniWord(filmini,"GVm2",0)) )	param[ 7]=(int)((float)param[ 5]-((float)param[ 5]-(float)param[ 9])*(float)Vref2/10000.0+0.5);
	if ( ! (param[ 8]=getIniWord(filmini,"GVm1",0)) )	param[ 8]=(int)((float)param[ 5]-((float)param[ 5]-(float)param[ 9])*(float)Vref1/10000.0+0.5);
	if ( ! (param[11]=getIniWord(filmini,"BVm3",0)) )	param[11]=(int)((float)param[10]-((float)param[10]-(float)param[14])*(float)Vref3/10000.0+0.5);
	if ( ! (param[12]=getIniWord(filmini,"BVm2",0)) )	param[12]=(int)((float)param[10]-((float)param[10]-(float)param[14])*(float)Vref2/10000.0+0.5);
	if ( ! (param[13]=getIniWord(filmini,"BVm1",0)) )	param[13]=(int)((float)param[10]-((float)param[10]-(float)param[14])*(float)Vref1/10000.0+0.5);

//\\\\!!!

	text_forecolor=WHITE;
	text_backcolor=SKIPMODE;

	if ( edit_flag ) for ( i=0 ; i<ALLPARAM ; i++ ) drawParam(i,lWHITE);

// 2 row
	getIni(filmini,"name",filmname);	if ( !(*filmname) ) strcpy(filmname,"undefined");
	sprintf(sTime,"Film \"%s\" %c",filmname,(!isNega)? 'P' : 'N');
	infotext(sTime,2);

// 4 row
	strcpy(sTime,"byTable: NO  calcHS: NO ");
	if ( byTable ) memmove(sTime+ 9,"YES",3);
	if ( calcHS )  memmove(sTime+21,"YES",3);
	infotext(sTime,4);

	swin.win0=5;
	swin.win1=(!isNega) ? 128 : 0;
	swin.X=(dword)getIniWord("scan.ini","scan_x",0);   //+14L; // scan start x,y
	swin.Y=(dword)getIniWord("scan.ini","scan_y",0);   //+58L;
	scan_dX_1770=(dword)getIniWord("scan.ini","scan_dx",2400);
	scan_dY_1770=(dword)getIniWord("scan.ini","scan_dy",1600);
	dpi=(dword)getIniWord("scan.ini","dpi",1770);

//	dBias=getIniWord("scan.ini","bias",0);    // Exposure Bias scroll=-200...0...200

new_scan:;

	swin.resX=dpi;
	swin.resY=dpi;
	swin.dX=(dpi*min(scan_dX_1770,2700L-swin.X))/1770L;
	swin.dY=(dpi*min(scan_dY_1770,1800L-swin.Y))/1770L;
	scan_dX=(word)swin.dX;
	scan_dY=(word)swin.dY;

	win_dX=(v_width<<2)/5;
	win_dY=v_height-max(ALLPARAM*(PARAM_DY+PARAM_BRD),256+8);
	win_dY_scan_dX=(dword)win_dY*swin.dX;
	win_dX_scan_dY=(dword)win_dX*swin.dY;
	if ( win_dX_scan_dY > win_dY_scan_dX ) win_dX=(word)(win_dY_scan_dX/swin.dY);
	else                                   win_dY=(word)(win_dX_scan_dY/swin.dX);
	cshift=0; if ( dpi>600L ) { cshift++; if ( dpi>1400L ) cshift++; }
	swin.X+=(2L-(dword)cshift);

// 0 row
	if ( win_dX>=(word)swin.dX ) sprintf(sTime,"MAG %4.2fx @ %ddpi",(float)win_dX/(float)swin.dX,(word)dpi);
	else                         sprintf(sTime,"MAG 1/%4.2fx @ %ddpi",(float)swin.dX/(float)win_dX,(word)dpi);
	infotext(sTime,0);

	if ( (fh=_creat(fname,0))==-1 ) fh=0;
	else {
		linlen=0xFFFFFFFCL&(3L*(swin.dY+1L));
		bmpfh.bfType=('M'<<8)|'B';             // 'BM' Specifies the type of file
		bmpfh.bfSize=54L+swin.dX*linlen;       // Specifies the size in DWORDs of the file
		bmpfh.bfReserved1=0;                   // Is reserved and must be set to zero
		bmpfh.bfReserved2=0;                   // Is reserved and must be set to zero
		bmpfh.bfOffBits=54L;                   // Specifies in bytes the offset from the BITMAPFILEHEADER
																					 // of the actual bitmap in the file
		bmpfh.biSize=40L;                      // Specifies the number of bytes required by the
																					 // BITMAPINFOHEADER structure
		bmpfh.biWidth=swin.dY;                 // Specifies the width of the bitmap in pixels
		bmpfh.biHeight=swin.dX;                // Specifies the height of the bitmap in pixels
		bmpfh.biPlanes=1;                      // Specifies the number of planes for the target device
																					 // and must be set to 1
		bmpfh.biBitCount=24;                   // Specifies the number of bits per pixel. This value must
																					 // be 1, 4, 8, or 24
		bmpfh.biCompression=0L;                // Specifies the type of compression for a compressed
																					 // bitmap
		bmpfh.biSizeImage=swin.dX*linlen;      // Specifies the size in bytes of the image
		bmpfh.biXPelsPerMeter=(10000L*dpi)/254L; // Specifies the horizontal resolution in pixels per
																					 // meter the target device for the bitmap
		bmpfh.biYPelsPerMeter=(10000L*dpi)/254L;// Specifies the vertical resolution in pixels per
																					 // meter of the target device for the bitmap
		bmpfh.biClrUsed=0L;                    // Specifies the number of color indexes in the color
																					 // table actually used by the bitmap
		bmpfh.biClrImportant=0L;               // Specifies the number of color indexes that are
																					 // considered important for displaying the bitmap
		if ( _write(fh,(char*)&bmpfh,54)!=54 ) { _close(fh); fh=0; }
		else {
			i=strlen(fname)+5-(v_width-TEXTBEGX)/char_width;
			if ( i>0 ) sprintf(sTime,"Save>%s",fname+i);
			else       sprintf(sTime,"Save %s",fname);
			infotext(sTime,6);
		}
	}

	setBoxColor(XOFF,YOFF,XOFF+win_dX-1,YOFF+win_dY-1,BLACK);
	setFrameColor(XOFF-1,YOFF-1,XOFF+win_dX,YOFF+win_dY,lWHITE);
	setBoxColor(XOFF,2*YOFF+win_dY,XOFF+win_dX-1,2*YOFF+win_dY+char_height,BLACK);

	for ( i=0 ; i<256 ; i++ ) h_r[i]=h_g[i]=h_b[i]=h_rm[i]=h_gm[i]=h_bm[i]=0L;

	Set_Window(&swin);
	setup_scanner();
	ScanStart();

	for ( scan_X=0; scan_X<cshift ; scan_X++ ) {
		LineStart();
		for ( scan_Y=0 ; scan_Y<scan_dY ; scan_Y++ ) {
			if ( !PixelRead( &r, &g, &b ) ) {
				mes.msg="SCANNER\nCannot read pixel";
				goto scan_error;
			}
			if ( scan_X ) { b2[2*scan_Y]=r; b2[2*scan_Y+1]=b; }
			else          { b1[2*scan_Y]=r; b1[2*scan_Y+1]=b; }
		}
		LineEnd();
	}

	t_start=timeRTC();

	scan_X_min=(word)((float)scan_dX*(float)borders/100.0);
	scan_X_max=scan_dX-scan_X_min;
	scan_Y_min=(word)((float)scan_dY*(float)borders/100.0);
	scan_Y_max=scan_dY-scan_Y_min;

	inbord=0;
	for ( scan_X=0 ; scan_X<scan_dX ; scan_X++ ) {
		win_x =XOFF+(word)(((win_dX-1)*(dword) scan_X   )/((dword)scan_dX-1L));
		win_nx=XOFF+(word)(((win_dX-1)*(dword)(scan_X+1))/((dword)scan_dX-1L));
		linlen=0xFFFFFFFCL&(3L*(scan_dY+1));
		LineStart();
		for ( scan_Y=0 ; scan_Y<scan_dY ; scan_Y++ ) {
			if ( (scan_Y>scan_Y_min) && (scan_Y<scan_Y_max) &&
					 (scan_X>scan_X_min) && (scan_X<scan_X_max) )
				inbord|=0x03;
			else
				inbord&=0xFE;

			if ( !PixelRead( &r, &g, &b ) ) { mes.msg="SCANNER\nCannot read data"; goto scan_error; }
			if ( cshift ) {
				rs0=r; rs1=b;
				r=b1[2*scan_Y]; b=b1[2*scan_Y+1];
				if ( cshift==2 ) {
					b1[2*scan_Y  ]=b2[2*scan_Y  ]; b2[2*scan_Y  ]=rs0;
					b1[2*scan_Y+1]=b2[2*scan_Y+1]; b2[2*scan_Y+1]=rs1;
				}
				else {
					b1[2*scan_Y  ]=rs0;
					b1[2*scan_Y+1]=rs1;
				}
			}

/*
			if ( fb!=-1 ) {
				i=3*((((dword)scan_Y*1770L)/swin.resY)+swin.Y+1);
				if ( tul=brtbl[i  ] ) {
					tul=((unsigned long)brtbl[0]*(unsigned long)r)/tul; if ( tul>255 ) tul=255;
					r=(byte)tul;
				}
				if ( tul=brtbl[i+1] ) {
					tul=((unsigned long)brtbl[1]*(unsigned long)g)/tul; if ( tul>255 ) tul=255;
					g=(byte)tul;
				}
				if ( tul=brtbl[i+2] ) {
					tul=((unsigned long)brtbl[2]*(unsigned long)b)/tul; if ( tul>255 ) tul=255;
					b=(byte)tul;
				}
			}
*/
			iR=(word)r; iG=(word)g; iB=(word)b;
			if ( byTable && (!isNega) ) {
//				if ( isNega ) { iR=(word)cNega[r]; iG=(word)cNega[g]; iB=(word)cNega[b]; }
//				if ( isNega ) { iR=(word)r       ; iG=(word)g       ; iB=(word)b;        }
//				else          {
				iR=(word)cPosi[r]; iG=(word)cPosi[g]; iB=(word)cPosi[b]; }
//			}
//			else            { iR=(word)r;        iG=(word)g;        iB=(word)b; }

			if ( calcHS ) {
				if ( isNega ) { iH=6; iS=10; }
				else          { iH=4; iS= 4; }
				if      ( iB<=iG && iG<=iR ) iG-=(iR-iG)/iH;
				else if ( iG<=iB && iB<=iR ) iG-=(iR-iB)/iH;
				else if ( iB<=iR && iR<=iG ) iR-=(iG-iR)/iH;
				else if ( iR<=iB && iB<=iG ) iR-=(iG-iB)/iH;
				else if ( iR<=iG && iG<=iB ) iG-=(iB-iG)/iH;
				else if ( iG<=iR && iR<=iB ) iG-=(iB-iR)/iH;
				iR=min(max(iR,0),255);
				iG=min(max(iG,0),255);
				iB=min(max(iB,0),255);
				if      ( iB<=iG && iB<=iR ) { iR+=(iR-iB)/iS; iG+=(iG-iB)/iS; }
				else if ( iG<=iB && iG<=iR ) { iR+=(iR-iG)/iS; iB+=(iB-iG)/iS; }
				else if ( iR<=iB && iR<=iG ) { iG+=(iG-iR)/iS; iB+=(iB-iR)/iS; }
				iR=min(max(iR,0),255);
				iG=min(max(iG,0),255);
				iB=min(max(iB,0),255);
			}

			if ( inbord & 0x01 ) {
				h_r[r]++;         h_g[g]++;         h_b[b]++;
				h_rm[(byte)iR]++; h_gm[(byte)iG]++; h_bm[(byte)iB]++;
			}

			rgb=RGB((byte)iR,(byte)iG,(byte)iB);

			if ( fh && (linlen>=3L)) {
				if ( _write(fh,(char*)&rgb,3)!=3 ) { _close(fh); fh=0; }
				linlen-=3L;
			}

			win_y =YOFF+(word)(((win_dY-1)*(dword) scan_Y   )/((dword)scan_dY-1L));
			win_ny=YOFF+(word)(((win_dY-1)*(dword)(scan_Y+1))/((dword)scan_dY-1L));
			if ( ((win_nx-win_x)>1) || ((win_ny-win_y)>1) )
				setBoxColor(win_x, win_y, min(win_nx,XOFF+win_dX)-1, min(win_ny,YOFF+win_dY)-1, rgb);
			else if ( ((win_nx-win_x)!=0) && ((win_ny-win_y)!=0) )
				setPixelColor(win_x,win_y,rgb);

		}
		LineEnd();
		if ( fh && linlen ) {
			if ( _write(fh,(char*)&rgb,(word)linlen)!=(word)linlen ) { _close(fh); fh=0; }
		}

		setBoxColor(XOFF,2*YOFF+win_dY,min(win_nx,XOFF+win_dX)-1,2*YOFF+win_dY+char_height,lWHITE);
		if ( win_nx<(XOFF+win_dX-1) )
			setBoxColor(win_nx,2*YOFF+win_dY,XOFF+win_dX-1,2*YOFF+win_dY+char_height,BLACK);
		t_done=timeRTC()-t_start;
		t_rest=(scan_dX*t_done)/(scan_X+1)-t_done;
		sprintf(sTime,"%d:%2.2d",(word)(t_done/60L),(word)(t_done%60L));
		text_y=2*YOFF+win_dY+1;
		text_x=XOFF+1;
		pString(sTime);
		sprintf(sTime,"%d:%2.2d",(word)(t_rest/60L),(word)(t_rest%60L));
		text_x=XOFF+win_dX-strlen(sTime)*char_width+1;
		pString(sTime);

		if ( key=getKey(NOWAITKEY) ) {
			if ( (key>='a') && (key<='z') ) key-=0x20;
			switch ( key ) {
			case 0x1B: // ESC
				MessageBox("ESC key pressed ...");
//				waitClearKbd();
				if ( fh ) { _close(fh);	unlink(fname); }
				goto scan_aborted;
			case 'H':
				plot_hist=1-plot_hist;
				break;
			case 'N':
				if ( inbord & 0x02 )	drawNumbers();
				break;
			default:
				break;
			}
		}
		if ( (inbord & 0x02) && plot_hist ) plotHistogram();
	}
	if ( fh ) _close(fh);
scan_aborted:;
	fh=0;
	if ( inbord & 0x02 ) {
		if ( !plot_hist ) plotHistogram();
		drawNumbers();
	}
	MessageBox("! PARKING HEAD !");
	ScanEnd();

	setBoxColor(0,2*YOFF+win_dY,XOFF+win_dX-1,2*YOFF+win_dY+char_height,SYSCOLOR);

	prm=0;
	if ( histcrop && (inbord&0x02) ) { calc_new_ref(histcrop); inbord|=0x04; }

	do {
		MessageBox("Ready ...");
		if ( !getIniWord("scan.ini","waitkey",1) ) goto out_of_scan;
		if ( !edit_flag ) { waitClearKbd(); goto out_of_scan; }

		drawParam(prm,YELLOW);
		key=waitClearKbd(); if ( (key>='a') && (key<='z') ) key-=0x20;
		drawParam(prm, lWHITE);

		MessageBox(" ");

		prm_changed=0;
		switch(key) {
		case 0x1B:
			goto out_of_scan;
		case 0x4800: // UP
			if ( !prm ) prm=ALLPARAM;
			prm--;
			break;
		case 0x5000: // DOWN
			if ( (++prm)>=ALLPARAM ) prm=0;
			break;
		case 0x4B00: // LEFT
			if ( param[prm] ) {
				param[prm]--;
				prm_changed=1;
			}
			break;
		case 0x4D00: // RIGHT
			if ( (param[prm])!=255 ) {
				param[prm]++;
				prm_changed=1;
			}
			break;
		case 0x0D:
			key=0;
			break;
		case 'F':    // F - focus procedure
			MessageBox("Tune FOCUS column <-+->");
			do {
				setBoxColor (XOFF+focusX-3,2*YOFF+win_dY,XOFF+focusX+3,2*YOFF+win_dY+char_height,RED);
				setBoxColor (XOFF+focusX-2,2*YOFF+win_dY-1,XOFF+focusX+2,2*YOFF+win_dY+char_height,RED);
				setLineColor(XOFF+focusX,YOFF+win_dY+1,XOFF+focusX,2*YOFF+win_dY+char_height,RED);
				key=waitClearKbd(); if ( (key>='a') && (key<='z') ) key-=0x20;
				setBoxColor (XOFF+focusX-3,YOFF+win_dY+1,XOFF+focusX+3,2*YOFF+win_dY+char_height,SYSCOLOR);
				switch(key) {
				case 0x1B:
					goto out_of_focus;
				case 0x4B00: // LEFT
					if ( focusX ) focusX--;
					break;
				case 0x4D00: // RIGHT
					if ( focusX<(win_dX-1) ) focusX++;
					break;
				case 0x4800: // UP
					if ( focusX<(win_dX-1) ) focusX+=(win_dX>>5);
					if ( focusX>(win_dX-1) ) focusX=win_dX-1;
					break;
				case 0x5000: // DOWN
					if ( focusX ) focusX-=(win_dX>>5);
					if ( focusX<0 ) focusX=0;
					break;
				case 0x0D:
					key=0;
					break;
				}
			} while ( key ); key='F';
			focus_x=swin.X+((scan_dX_1770*(dword)focusX)/(win_dX-1))-1L;
			MessageBox("Seek to FOCUS column ...");
// now must select, where to move scanner head .... result - in pass_puls
			setup_scanner();
//			scan_X=0;
//			scan_dX=min( (word)swin.dX, win_dX ) ;
			if ( ! FilmHeadPosition(6,focus_x) ) goto scan_move_error;
			setFrameColor(FBEGX-1,FBEGY-1,FBEGX+FWIDTH  ,FBEGY+256  ,lWHITE);
			setBoxColor(  FBEGX,  FBEGY,  FBEGX+FWIDTH-1,FBEGY+256-1, BLACK);
			Focus('A');
			focus_check_sub(0);
			focus_check_sub(0);
			focus_check_sub(0);
			focus_check_sub(0);
			mf=of=0L;
			do {
				if ( !focus_check_sub(1) ) {
					mes.msg="SCANNER\nCannot complete focus sub";
					goto scan_error;
				}
				key=getKey(NOWAITKEY);
			} while ( (key!=0x1B) && (key!=0x0D) ) ;
			MessageBox("! PARKING HEAD !");
			ScanEnd();
			if ( !FilmHeadPosition(7,3000) ) goto scan_move_error;
			setBoxColor(FBEGX-1,FBEGY-1,FBEGX+FWIDTH  ,FBEGY+256  ,SYSCOLOR);
out_of_focus:;
			break;
		case 'U':		// U - update reference points
			if ( inbord & 0x04 ) {
				param[ 0]=nVpR; drawParam( 0, lWHITE);
				param[ 4]=nVmR; drawParam( 4, lWHITE);
				recalc3ref( 0);
				param[ 5]=nVpG; drawParam( 5, lWHITE);
				param[ 9]=nVmG; drawParam( 9, lWHITE);
				recalc3ref( 5);
				param[10]=nVpB; drawParam(10, lWHITE);
				param[14]=nVmB; drawParam(14, lWHITE);
				recalc3ref(10);
			}
			break;
		default:
			break;
		}

		if ( prm_changed ) {
			if ( (prm== 0) || (prm== 4) ) recalc3ref( 0);
			if ( (prm== 5) || (prm== 9) ) recalc3ref( 5);
			if ( (prm==10) || (prm==14) ) recalc3ref(10);
		}

	} while ( key ) ;
	goto new_scan;

/*----------------------------------------------*/
scan_move_error:;
	mes.msg="SCANNER\nFailed to move head";
scan_error:;
	if ( fh ) { _close(fh);	unlink(fname); fh=0; }
	GBox(&mes);
	waitClearKbd();
out_of_scan:;
	Port_Initialise(LPTnum);
	setTextMode();
/*
	tul=rgb=0L; for ( i=0 ; i<256 ; i++ ) { tul+=i*h_r[i]; rgb+=h_r[i]; }
	if ( rgb ) printf("%6.2f",(float)tul/(float)rgb);
	tul=rgb=0L; for ( i=0 ; i<256 ; i++ ) { tul+=i*h_g[i]; rgb+=h_g[i]; }
	if ( rgb ) printf("\t%6.2f",(float)tul/(float)rgb);
	tul=rgb=0L; for ( i=0 ; i<256 ; i++ ) { tul+=i*h_b[i]; rgb+=h_b[i]; }
	if ( rgb ) printf("\t%6.2f\n",(float)tul/(float)rgb);
*/

	if ( fb ) _close(fb);
	if ( b1 ) free(b1);
	if ( b2 ) free(b2);
	if ( h_r ) free(h_r);
	if ( h_g ) free(h_g);
	if ( h_b ) free(h_b);
	if ( eeprom ) free(eeprom);

	for ( i=0 ; i<ALLPARAM ; i++ ) printf("%s = %3d\n",sParam[i],param[i]);

	return;
}

/*
void Eeprom_comp_load(void)
{
	int i;
	long lr0;

	EepromRead(eeprom,0x2E,20);   // read 20 bytes from offs.2E to eeprom
	for ( i=0 ; i<20 ; i++ ) pcmp[i]=eeprom[i];
	lr0=GetCurrentTime()+100L; while ( GetCurrentTime()<lr0 ) ;
	EepromRead(eeprom,0x38,20);   // read 20 bytes from offs.38 to eeprom
	for ( i=0 ; i<20 ; i++ ) ncmp[i]=eeprom[i];
}


byte vref_comp(byte to, byte from)
{
	word res;
	res=(word)to+(word)from;
	if ( from<0x80 ) { if ( res>0xFF ) res=0xFF; }
	else             { if ( res<0x100 ) res=0x00; }
	return ( to=(byte)res ) ;
}
*/
int mw=0;
int mh=0;
void MessageBox(char* str)
{
	if ( mw && mh ) setBoxColor(MESSAGEX,MESSAGEY,MESSAGEX+mw,MESSAGEY+mh,SYSCOLOR);
	mh=pStringFontColor("s70.fnt",0,0,str,0L,SF_GETHEIGHT);
	mw=pStringFontColor("s70.fnt",MESSAGEX,MESSAGEY+mh,str,YELLOW,SF_YCENTER|SF_USECOLOR);
}

void drawParam(int i, dword color)
{
	char sbuf[4];

	text_y=PARAM_Y+i*(PARAM_DY+PARAM_BRD)+2;
	text_x=XOFF;
	pString(sParam[i]);
	if ( param[i]       ) setBoxColor( PARAM_X         ,text_y-2,PARAM_X+param[i]-1,text_y-2+PARAM_DY-1,color);
	if ( param[i]!=0xFF )	setBoxColor( PARAM_X+param[i],text_y-2,PARAM_X+254       ,text_y-2+PARAM_DY-1,BLACK);
	setFrameColor(PARAM_X+255+PARAM_BRD  ,text_y-2,PARAM_X+255+PARAM_BRD+3*char_width+2,text_y-2+PARAM_DY-1,color);
	setBoxColor(  PARAM_X+255+PARAM_BRD+1,text_y-1,PARAM_X+255+PARAM_BRD+3*char_width+1,text_y-2+PARAM_DY-2,BLACK);
	sprintf(sbuf,"%3d",param[i]);
	text_x=PARAM_X+255+PARAM_BRD+2;
	pString(sbuf);
}

int waitClearKbd(void)
{
	while ( getKey(NOWAITKEY) ) ;
	return getKey(WAITKEY);
}

int focus_check_sub(int flag)
{
	dword f;
	word lev;

	if ( ! ContrastRead(&r,&g,&b) ) return 0;
	f=(((((dword)r)<<8)|(dword)g)<<8)|(dword)b;
	if ( mf<f ) mf=f;					// maximum focus achieved
	f=(7*of+f)>>3;
	of=f;
	lev=(word)(255.0*f/mf);
	if ( flag ) {
				setBoxColor( FBEGX, FBEGY        , FBEGX+FWIDTH-1,FBEGY+256-1, BLACK);
			if ( lev )
				setBoxColor( FBEGX, FBEGY+255-lev, FBEGX+FWIDTH-1,FBEGY+255-1, GREEN);
	}
	return 1;
}

void setup_scanner(void)
{
	byte scan_mode[7];
//	double v1,v2;
	int i;

	for ( i=0 ; i<BASPARAM ; i++ ) cp_param[i]=/*vref_comp(*/param[i]/*,pcmp[i])*/;
//	v2=max(min((double)cp_param[19]*pow(2.0,dBias/100.0),255),1);
	scan_mode[0]='F'; // also can be 'B' - seems to be scan direction
	scan_mode[1]='R'; // also can be 'G'
	scan_mode[2]= 2 ; // always 2
	scan_mode[5]=(!isNega) ? 'H' : 'L';
	if ( !cp_param[18] ) cp_param[18]=1;
	if ( !cp_param[19] ) cp_param[19]=1;
	scan_mode[4]=cp_param[18];
	scan_mode[3]=cp_param[19];
	scan_mode[6]='P'; // also can be 'R' && 'I'
	Set_Scan_Mode(7,scan_mode);
	Set_AD(cp_param);
	Set_Brightness(param[BASPARAM]);
}

void drawNumbers(void)
{
	int i;
	int i_rx,i_gx,i_bx,i_rn,i_gn,i_bn;
	char bbuf[30];
	float u,v,k;

	i_rx=i_gx=i_bx=0;
	i_rn=i_gn=i_bn=-1;
	for ( i=0 ; i<256 ; i++ ) {
		if ( (i_rn==-1) && h_r[i] ) i_rn=i;
		if ( (i_gn==-1) && h_g[i] ) i_gn=i;
		if ( (i_bn==-1) && h_b[i] ) i_bn=i;
	}
	for ( i=255 ; i>=0 ; i-- ) {
		if ( (!i_rx) && h_r[i] ) i_rx=i;
		if ( (!i_gx) && h_g[i] ) i_gx=i;
		if ( (!i_bx) && h_b[i] ) i_bx=i;
	}

	if ( isNega ) {
		i=i_rn; i_rn=255-i_rx; i_rx=255-i;
		i=i_gn; i_gn=255-i_gx; i_gx=255-i;
		i=i_bn; i_bn=255-i_bx; i_bx=255-i;
	}

	u=get_volt(i_rx,0);
	v=get_volt(i_rn,0);
	k=1.0+param[15]/70.0;
	sprintf(bbuf,"R %5.3f-%5.3f (%5.3f-%5.3f)",v/k,u/k,v,u);
	infotext(bbuf,8);
	u=get_volt(i_gx,1);
	v=get_volt(i_gn,1);
	k=1.0+param[16]/70.0;
	sprintf(bbuf,"G %5.3f-%5.3f (%5.3f-%5.3f)",v/k,u/k,v,u);
	infotext(bbuf,9);
	u=get_volt(i_bx,2);
	v=get_volt(i_bn,2);
	k=1.0+param[17]/70.0;
	sprintf(bbuf,"B %5.3f-%5.3f (%5.3f-%5.3f)",v/k,u/k,v,u);
	infotext(bbuf,10);
}

float get_volt(int k, int col)
{
	if ( (col>2) || (k<0) || (k>255) ) return 0.0;

	if ( k <  64 )
		return (basevoltage-(((float)param[5*col  ]- (float)k        /63.5*((float)param[5*col  ]-(float)param[5*col+1]))*showvoltage/255.0))/1000.0;
	if ( k < 128 )
		return (basevoltage-(((float)param[5*col+1]-((float)k- 63.5) /64.0*((float)param[5*col+1]-(float)param[5*col+2]))*showvoltage/255.0))/1000.0;
	if ( k < 192 )
		return (basevoltage-(((float)param[5*col+2]-((float)k-127.5) /64.0*((float)param[5*col+2]-(float)param[5*col+3]))*showvoltage/255.0))/1000.0;
	return   (basevoltage-(((float)param[5*col+3]-((float)k-191.5) /63.5*((float)param[5*col+3]-(float)param[5*col+4]))*showvoltage/255.0))/1000.0;
}

void calc_new_ref(word hcrop)
{
	int flg,i;
	dword l1,l2;

	flg=0; l1=l2=0L; for ( i=0 ; i<256 ; i++ ) l2+=h_r[i];
	for ( i=0 ; i<256 ; i++ ) { l1+=h_r[i];
		switch ( flg ) {
		case 0:
			if ( (1000.0*(float)l1) >= ((float)hcrop*(float)l2) ) 					{ dVpR=i; flg++; }
			break;
		case 1:
			if ( (1000.0*(float)l1) >= (((float)(1000-hcrop))*(float)l2) ) { dVmR=i; flg++; }
		}
	}
	if ( flg==1 ) dVmR=255;

	flg=0; l1=l2=0L; for ( i=0 ; i<256 ; i++ ) l2+=h_g[i];
	for ( i=0 ; i<256 ; i++ ) { l1+=h_g[i];
		switch ( flg ) {
		case 0:
			if ( (1000.0*(float)l1) >= ((float)hcrop*(float)l2) ) 					{ dVpG=i; flg++; }
			break;
		case 1:
			if ( (1000.0*(float)l1) >= (((float)(1000-hcrop))*(float)l2) ) { dVmG=i; flg++; }
		}
	}
	if ( flg==1 ) dVmG=255;

	flg=0; l1=l2=0L; for ( i=0 ; i<256 ; i++ ) l2+=h_b[i];
	for ( i=0 ; i<256 ; i++ ) { l1+=h_b[i];
		switch ( flg ) {
		case 0:
			if ( (1000.0*(float)l1) >= ((float)hcrop*(float)l2) ) 					{ dVpB=i; flg++; }
			break;
		case 1:
			if ( (1000.0*(float)l1) >= (((float)(1000-hcrop))*(float)l2) ) { dVmB=i; flg++; }
		}
	}
	if ( flg==1 ) dVmB=255;

	show_new_ref(nVpR=param[ 0]-(int)((float)     dVpR *(param[ 0]-param[ 1])/63.5), 0);
	show_new_ref(nVmR=param[ 4]+(int)((float)(255-dVmR)*(param[ 3]-param[ 4])/63.5), 4);
	show_new_ref(nVpG=param[ 5]-(int)((float)     dVpG *(param[ 5]-param[ 6])/63.5), 5);
	show_new_ref(nVmG=param[ 9]+(int)((float)(255-dVmG)*(param[ 8]-param[ 9])/63.5), 9);
	show_new_ref(nVpB=param[10]-(int)((float)     dVpB *(param[10]-param[11])/63.5),10);
	show_new_ref(nVmB=param[14]+(int)((float)(255-dVmB)*(param[13]-param[14])/63.5),14);
}

void show_new_ref(int newref,int i)
{
	char xbuf[4];

	text_y=PARAM_Y+i*(PARAM_DY+PARAM_BRD)+2;
	text_x=PARAM_X+255+PARAM_BRD+3*char_width+12;
	setFrameColor(PARAM_X+255+PARAM_BRD+3*char_width+10,text_y-2,PARAM_X+255+PARAM_BRD+6*char_width+12,text_y-2+PARAM_DY-1,(param[i]==newref) ? lWHITE : GREEN);
	setBoxColor(  PARAM_X+255+PARAM_BRD+3*char_width+11,text_y-1,PARAM_X+255+PARAM_BRD+6*char_width+11,text_y-2+PARAM_DY-2,BLACK);
	sprintf(xbuf,"%3d",newref);
	pString(xbuf);
}

void recalc3ref(int i)
{
	param[i+1]=(int)((float)param[i]-((float)param[i]-(float)param[i+4])*(float)Vref3/10000.0+0.5);
	drawParam(i+1,lWHITE);
	param[i+2]=(int)((float)param[i]-((float)param[i]-(float)param[i+4])*(float)Vref2/10000.0+0.5);
	drawParam(i+2,lWHITE);
	param[i+3]=(int)((float)param[i]-((float)param[i]-(float)param[i+4])*(float)Vref1/10000.0+0.5);
	drawParam(i+3,lWHITE);
}

void infotext(char* s, int row)
{
	int l;

	text_x=TEXTBEGX;
	text_y=YOFF+row*char_height;
	setBoxColor(text_x,text_y,v_width-1,text_y+char_height-1,SYSCOLOR);
	l=(v_width-TEXTBEGX)/char_width;
	if ( strlen(s) >=l ) s[l-1]='\0';
	pString(s);
}

void plotHistogram(void)
{
	drawHistBack(2,1,h_r,RED  );
	drawHistBack(1,1,h_g,GREEN);
	drawHistBack(0,1,h_b,BLUE );
	if ( byTable || calcHS ) {
		drawHistBack(2,0,h_rm,RED  );
		drawHistBack(1,0,h_gm,GREEN);
		drawHistBack(0,0,h_bm,BLUE );
	}
}

#define HIST_X (v_width-256-4)
#define HIST_Y (v_height-4)
#define HIST_YM (129+4)
#define HIST_XM (256+4)

void drawHistBack(int x, int y, dword* mx, dword color)
{
	int i;
	dword mx_max;
	word xb,yb;

	xb=HIST_X-x*HIST_XM;
	yb=HIST_Y-y*HIST_YM;

	mx_max=0L;
	for ( i=0 ; i<256 ; i++ ) if ( mx_max<mx[i] ) mx_max=mx[i];
	setBoxColor(xb,yb,xb+255,yb-128,BLACK);
	for ( i=0 ; i<histdiv ; i++ )	setLineColor(xb+(i<<8)/histdiv,yb-1,xb+(i<<8)/histdiv,yb-128,GRAY);
	if ( mx_max ) for ( i=0 ; i<256 ; i++ ) if ( mx[i] ) setLineColor(xb+i,yb-1,xb+i,yb-((mx[i]<<7)-1)/mx_max-1,color);
}

